package de.tuberlin.tfs.ocl.metamodel.expressions;

// import java.util.*;
// import de.tuberlin.tfs.ocl.metamodel.types.*;
import de.tuberlin.tfs.ocl.metamodel.converter.*;
// import ru.novosoft.uml.foundation.core.*;
// import ru.novosoft.uml.foundation.data_types.*;
// import ru.novosoft.uml.behavior.common_behavior.*;


public class MLetExpImpl extends MOclExpressionImpl implements MLetExp {

	protected MVariableDeclaration variable;
	protected MOclExpression in;


	/** Getter for property variable.
	 * @return Value of property variable.
	 */
	public MVariableDeclaration getVariable() {
		return variable;
	}

	/** Setter for property variable.
	 * @param variable value of property variable.
	 */
	public void  setVariable(MVariableDeclaration variable) {
		this.variable = variable;
	}

	/** Getter for property in.
	 * @return Value of property in.
	 */
	public MOclExpression getIn() {
		return in;
	}

	/** Setter for property in.
	 * @param in value of property in.
	 */
	public void  setIn(MOclExpression in) {
		this.in = in;
	}



	public String convert2OclString () throws NoSuchAttributeException {
		OclConverter.message("<LetExp>");

		StringBuffer strB = new StringBuffer();

		OclConverter.checkAttribute(variable, "variable", this);
		OclConverter.checkAttribute(variable.getType(), "type of variable", this);
		OclConverter.checkAttribute(variable.getInitExpression(), "init expression of variable", this);
		OclConverter.checkAttribute(in, "in expression", this);

		strB.append("let " + variable.getVarname() );
		strB.append(": " + variable.getType().getName() );
		strB.append(" = " + variable.getInitExpression().convert2OclString());
		strB.append(" in " + in.convert2OclString() );

		OclConverter.message("</LetExp>");
		return strB.toString();
	}

}
