/*
 * OclMetaModel1.java
 *
 * Created on 10. Juli 2002, 16:25
 */

package de.tuberlin.tfs.ocl.metamodel.test;

import de.tuberlin.tfs.ocl.metamodel.expressions.*;
import de.tuberlin.tfs.ocl.metamodel.types.*;
import ru.novosoft.uml.foundation.core.*;
 
/**
 *
 * @author  jgusulde
 */
public class OclMetaModel1 implements OclMetaModelInstance {
    
    /** Creates a new instance of OclMetaModel1 */
    public MOclConstraint getOclConstraint() {
        MOclConstraint constraint = new MOclConstraintImpl();
        MOperationCallExp expression = new MOperationCallExpImpl();
        constraint.setBody(expression);
        constraint.setKind(MOclConstraintKind.INV);
        MClassifier companyType = new MClassifierImpl();
        companyType.setName("Company");
        constraint.setConstrainedElement(companyType);
        
        
        // operation
        MOperation operation = new MOperationImpl();
        operation.setName(">");
        expression.setReferredOperation(operation);
        
        //type
        MClassifier type = new MClassifierImpl();
        type.setName("Boolean");
        expression.setType(type);
        
        // IntegerType
        MClassifier integerType = new MClassifierImpl();
        integerType.setName("Integer");
        
        //arguments
        
        // 1.Argument numberOfEmployees
        MAttributeCallExp argument1 = new MAttributeCallExpImpl();
        argument1.setType(integerType);
        MAttribute attribute = new MAttributeImpl();
        attribute.setName("numberOfEmployees");
        attribute.setType(integerType);
        argument1.setReferredAttribute(attribute);
        // source
        MVariableExp source = new MVariableExpImpl();
        MVariableDeclaration referredVariable = new MVariableDeclarationImpl();
        referredVariable.setVarname("self");
        referredVariable.setType(companyType);
        //source.setParentOperation(expression);
        source.setReferredVariable(referredVariable);
        source.setAppliedProperty(argument1);
        argument1.setSource(source);
        argument1.setParentOperation(expression);
        expression.addArguments(argument1);
        
        // 2.Argument 50
        MIntegerLiteralExp argument2 = new MIntegerLiteralExpImpl();
        argument2.setName("50");
        argument2.setType(integerType);
        argument2.setParentOperation(expression);
        expression.addArguments(argument2);
        
        return constraint;
    }
    
    public String getOclString() {
        return "context Company inv: self.numberOfEmployees > 50";
    }    
}
