/*
 * OclMetaModel11.java
 *
 * Created on 09/11/02, 23:20
 */

package de.tuberlin.tfs.ocl.metamodel.test;

import de.tuberlin.tfs.ocl.metamodel.expressions.*;
import de.tuberlin.tfs.ocl.metamodel.types.*;
import ru.novosoft.uml.foundation.core.*;

/**
 *
 * @author  tappeser
 */
public class OclMetaModel11 implements OclMetaModelInstance {

    /** Creates a new instance of OclMetaModel11 */
    public MOclConstraint getOclConstraint() {
	//OclConverter.setDebugMode(true);

        // Types ---------------------------------------------------------------
        //BooleanType
        MClassifier booleanType = new MClassifierImpl();
        booleanType.setName("Boolean");
        // IntegerType
        MClassifier integerType = new MClassifierImpl();
        integerType.setName("Integer");
	// DateType
        MClassifier dateType = new MClassifierImpl();
        dateType.setName("Date");
        
        //----------------------------------------------------------------------
        // Variable declaration: result
        MVariableExp resultExp = new MVariableExpImpl();
        MVariableDeclaration varD_result = new MVariableDeclarationImpl();
        varD_result.setVarname("result");
        varD_result.setType(integerType);
        resultExp.setReferredVariable(varD_result);
	resultExp.setType(integerType);
        //----------------------------------------------------------------------
        // Literal expression: 18
	MIntegerLiteralExp intExp1000 = new MIntegerLiteralExpImpl();
        intExp1000.setName("1000");
        intExp1000.setType(integerType);
        //----------------------------------------------------------------------
	// Attribute call expression: age
	MAttributeCallExp ageAttrCall = new MAttributeCallExpImpl();
	MAttribute attr_age = new MAttributeImpl();
	attr_age.setName("age");
	attr_age.setType(integerType);
	ageAttrCall.setReferredAttribute(attr_age);
	ageAttrCall.setType(integerType);
	//----------------------------------------------------------------------
	// Operation: *
	MOperation mulOp = new MOperationImpl();
	mulOp.setName("*");
        //----------------------------------------------------------------------
	// Operation: =
	MOperation equalOp = new MOperationImpl();
	equalOp.setName("=");
        //----------------------------------------------------------------------
	// Operation: income
	MOperation incomeOp = new MOperationImpl();
	incomeOp.setName("Person::income");
	//----------------------------------------------------------------------
	// Attribute call expression: d
	MAttributeCallExp dAttrCall = new MAttributeCallExpImpl();
	dAttrCall.setType(dateType);
	MAttribute attr_d = new MAttributeImpl();
	attr_d.setName("d");
	attr_d.setType(dateType);
	dAttrCall.setReferredAttribute(attr_d);


        // --- OclConstraint
        MOclConstraint constraint = new MOclConstraintImpl();
        constraint.setKind(MOclConstraintKind.POST);

	// --- Constrained Element
	MOperationCallExp incomeOperationCallExp = new MOperationCallExpImpl();
        constraint.setConstrainedElement(incomeOperationCallExp);
	incomeOperationCallExp.setReferredOperation(incomeOp);
	incomeOperationCallExp.addArguments(dAttrCall);
	incomeOperationCallExp.setType(integerType);

        // --- OperationCallExp
        MOperationCallExp operationCallExp = new MOperationCallExpImpl();
        constraint.setBody(operationCallExp);
        operationCallExp.setType(booleanType);
	operationCallExp.setReferredOperation(equalOp);


        // argument{1} -- Variable expression
        operationCallExp.addArguments(resultExp);

        // argument{2} -- OperationCallExp
        MOperationCallExp arg2 = new MOperationCallExpImpl();
        operationCallExp.addArguments(arg2);
        arg2.setType(integerType);
        arg2.setReferredOperation(mulOp);

        // argument{2_1}
	arg2.addArguments(ageAttrCall);

	// argument{2_1_1}
	arg2.addArguments(intExp1000);

        return constraint;
    }

    public String getOclString() {
        return "context Person::income(d:Date):Integer post: result = age * 1000";
    }
}
