/*
 * OclMetaModel13.java
 *
 * Created on 09/17/02, 20:36
 */

package de.tuberlin.tfs.ocl.metamodel.test;

import de.tuberlin.tfs.ocl.metamodel.expressions.*;
import de.tuberlin.tfs.ocl.metamodel.types.*;
import ru.novosoft.uml.foundation.core.*;
import ru.novosoft.uml.behavior.common_behavior.*;

/**
 *
 * @author  tappeser
 */
public class OclMetaModel13 implements OclMetaModelInstance {

    /** Creates a new instance of OclMetaModel11 */
    public MOclConstraint getOclConstraint() {
	//OclConverter.setDebugMode(true);

	// Types ---------------------------------------------------------------
	// IntegerType
	MClassifier integerType = new MClassifierImpl();
	integerType.setName("Integer");
	// OclMessageType
	MClassifier oclMessageType = new MClassifierImpl();
	oclMessageType.setName("OclMessage");
	// ObserverType
	MClassifier observerType = new MClassifierImpl();
	observerType.setName("Observer");

	//----------------------------------------------------------------------
	// Atribute call expression: message
	MAttributeCallExp messageAttrCall = new MAttributeCallExpImpl();
	MAttribute attr_message = new MAttributeImpl();
	attr_message.setName("message");
	attr_message.setType(oclMessageType);
	messageAttrCall.setReferredAttribute(attr_message);
	messageAttrCall.setType(oclMessageType);
	//----------------------------------------------------------------------
	// MessageExp with Signal: isSent
	MOclMessageExp isSentMessageExp = new MOclMessageExpImpl();
	MSendAction isSentSendAction = new MSendActionImpl();
	isSentMessageExp.setSentSignal(isSentSendAction);
	MSignal isSentSignal = new MSignalImpl();
	isSentSignal.setName("isSent");
	isSentSendAction.setSignal(isSentSignal);
	isSentMessageExp.setTarget(messageAttrCall);
	//----------------------------------------------------------------------
	// Literal expression: 12
	MIntegerLiteralExp intExp12 = new MIntegerLiteralExpImpl();
	intExp12.setName("12");
	intExp12.setType(integerType);
	//----------------------------------------------------------------------
	// Literal expression: 14
	MIntegerLiteralExp intExp14 = new MIntegerLiteralExpImpl();
	intExp14.setName("14");
	intExp14.setType(integerType);
	//----------------------------------------------------------------------
	// Association end call exp.: observer
	MAssociationEndCallExp observerAECExp = new MAssociationEndCallExpImpl();
	MAssociationEnd observerAEExp = new MAssociationEndImpl();
	observerAEExp.setName("observer");
	observerAECExp.setReferredAssociationEnd(observerAEExp);
	observerAECExp.setType(observerType);
	observerAEExp.setType(observerType);
	//----------------------------------------------------------------------
	// Op. call expression: hasChanged()
	MOperationCallExp hasChangedOpCallExp = new MOperationCallExpImpl();
	hasChangedOpCallExp.setType(oclMessageType);
	MOperation hasChangedOp = new MOperationImpl();
	hasChangedOp.setName("Subject::hasChanged");
	hasChangedOpCallExp.setReferredOperation(hasChangedOp);
	//----------------------------------------------------------------------
	// OperationCallExp: update(12, 14)
	MOperationCallExp updateOpCallExp = new MOperationCallExpImpl();
	updateOpCallExp.setType(oclMessageType);
	updateOpCallExp.setSource(observerAECExp);
	updateOpCallExp.addArguments(intExp12);
	updateOpCallExp.addArguments(intExp14);
	MOperation updateOp = new MOperationImpl();
	updateOp.setName("update");
	updateOpCallExp.setReferredOperation(updateOp);
	//----------------------------------------------------------------------
	// Variable declaration: message (with initialisation)
	MVariableDeclaration messageVarDecl = new MVariableDeclarationImpl();
	messageVarDecl.setVarname("message");
	messageVarDecl.setType(oclMessageType);
	messageVarDecl.setInitExpression(updateOpCallExp);

	// --- OclConstraint
	MOclConstraint constraint = new MOclConstraintImpl();
	constraint.setKind(MOclConstraintKind.POST);

	// --- Constrained Element
	constraint.setConstrainedElement(hasChangedOpCallExp);

	// --- letExpression
	MLetExp letExp = new MLetExpImpl();
	letExp.setVariable(messageVarDecl);
	letExp.setIn(isSentMessageExp);
	
	constraint.setBody(letExp);

	return constraint;
    }

    public String getOclString() {
        return "context Subject::hasChanged():OclMessage post: let message: OclMessage = observer^update(12,14) in message.isSent()";
    }
}
