/*
 * OclMetaModel1.java
 *
 * Created on 10. Juli 2002, 16:25
 */

package de.tuberlin.tfs.ocl.metamodel.test;

import de.tuberlin.tfs.ocl.metamodel.expressions.*;
import de.tuberlin.tfs.ocl.metamodel.types.*;
import ru.novosoft.uml.foundation.core.*;
import de.tuberlin.tfs.ocl.metamodel.expressions.MIntegerLiteralExpImpl;
import ru.novosoft.uml.foundation.core.MAttribute;
import ru.novosoft.uml.foundation.core.MAttributeImpl;
 
/**
 *
 * @author  jgusulde
 */
public class OclMetaModel4 implements OclMetaModelInstance {
    
    /** Creates a new instance of OclMetaModel1 */
    public MOclConstraint getOclConstraint() {
        // Types ---------------------------------------------------------------
        //BooleanType
        MClassifier booleanType = new MClassifierImpl();
        booleanType.setName("Boolean");
        // IntegerType
        MClassifier integerType = new MClassifierImpl();
        integerType.setName("Integer");
        // PersonType
        MClassifier companyType = new MClassifierImpl();
        companyType.setName("Company");
        // CompanyType
        MClassifier jobType = new MClassifierImpl();
        jobType.setName("Job");
       //----------------------------------------------------------------------
        // VarialbeDeclaratin --------------------------------------------------
        // self
        MVariableDeclaration varD_self = new MVariableDeclarationImpl();
        varD_self.setVarname("self");
        varD_self.setType(jobType);
        //----------------------------------------------------------------------
        
        
        
        // --- OclConstraint
        MOclConstraint constraint = new MOclConstraintImpl();
        constraint.setKind(MOclConstraintKind.INV);
        constraint.setConstrainedElement(jobType);
        
        // --- OperationCallExp
        MOperationCallExp operationCallExp = new MOperationCallExpImpl();
        constraint.setBody(operationCallExp);
        operationCallExp.setType(booleanType);
        // operation
        MOperation greaterEqualOperation = new MOperationImpl();
        greaterEqualOperation.setName(">=");
        operationCallExp.setReferredOperation(greaterEqualOperation);
        

        // --- argument{1} -- AttributeCallExp
        MAttributeCallExp attributeCallExp = new MAttributeCallExpImpl();
        operationCallExp.addArguments(attributeCallExp);
        attributeCallExp.setType(integerType);
        // Attribute
        MAttribute attribute = new MAttributeImpl();
        attribute.setName("numberOfEmployees");
        attribute.setType(integerType);
        attributeCallExp.setReferredAttribute(attribute);
        // source -- MAssociationEndCallExp
        MAssociationEndCallExp associationEndCallExp = new MAssociationEndCallExpImpl();
        attributeCallExp.setSource(associationEndCallExp);
        // source -- VarialbeExp
        MVariableExp varExp = new MVariableExpImpl();
        varExp.setReferredVariable(varD_self);
        associationEndCallExp.setSource(varExp);
        // referredAssociationEnd -- AssociatinEnd
        MAssociationEnd associationEnd = new MAssociationEndImpl();
        associationEnd.setName("employer");
        associationEnd.setType(companyType);
        associationEndCallExp.setReferredAssociationEnd(associationEnd);
        
        // --- argument{2} -- IntegerLiteralExp
        MIntegerLiteralExp intExpOne = new MIntegerLiteralExpImpl();
        operationCallExp.addArguments(intExpOne);
        intExpOne.setName("1");
        intExpOne.setType(integerType);
        
        
        
        return constraint;
    }
    
    public String getOclString() {
        return "context Job inv: self.employer.numberOfEmployees >= 1";
    }    
}
