/*
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 *
 * Contributors:
 *             Eduard Weiss
 *                 Tony Modica
 *                 Frank Hermann
 *                 Holger Endert
 *
 */
package vocleditor.action;

import org.eclipse.gef.ui.actions.EditorPartAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.ui.IEditorPart;

import VOCLModel.VOCLDiagramm;

import vocleditor.editors.VOCLEditor;
import converter.Converter;
//import converter.Converter;


/**
 * @author eddi
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ConvertToOclAction extends EditorPartAction {
    static public String RUN_CONVERTER = "Action hinzu";
    private VOCLDiagramm diagramm;

    /**
     * @param editor
     */
    public ConvertToOclAction(IEditorPart editor) {
        super(editor);
        setDescription("Convert to ocl");
        setText("Run converter");
    }

    /* (non-Javadoc)
     * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
     */
    protected boolean calculateEnabled() {
        return getEditorPart() != null;
    }

    /* (non-Javadoc)
     * @see org.eclipse.gef.ui.actions.EditorPartAction#setEditorPart(org.eclipse.ui.IEditorPart)
     */
    protected void setEditorPart(IEditorPart part) {
        super.setEditorPart(part);
    }

    /* (non-Javadoc)
     * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#init()
     */
    protected void init() {
        super.init();
        setToolTipText("OCL-Converter");
        setId(RUN_CONVERTER);
    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.action.IAction#run()
     */
    public void run() {

        diagramm=((VOCLEditor)getEditorPart()).getVOCLDiagramm();
        String result= new String("");
        result=Converter.convert(diagramm);
        MessageDialog.openInformation(((VOCLEditor)getEditorPart()).getSite().getShell()
        								,"Result",result);	
    }
}
