/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
 
package vocleditor.commands.delete;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import VOCLModel.AssociationEndRoleSource;
import VOCLModel.AssociationEndRoleTarget;
import VOCLModel.AssociationRole;
import VOCLModel.ClassifierNode;
import VOCLModel.NavExpContainer;

/**
 * @author eddi
 */
public class DeleteAssociationAtClassifierNode  {


	private	ClassifierNode classifier;
	private List assERS ;
	private List assERT ;
	

	/**
	 * Constructor of this command - no parameters needed
	 */
	public DeleteAssociationAtClassifierNode(ClassifierNode delClassifier){
		this.classifier=delClassifier;
	}

	/**
	 * Deletes all AssociationEndRoles of the given classifier
	 * @param classifier - the classifier
	 */
	public void execute() {
		assERS = new LinkedList();
		assERT = new LinkedList();
		List removeAssER=new LinkedList();
		for (Iterator it = classifier.getSource().iterator(); it.hasNext();) {
			AssociationEndRoleSource assERs = (AssociationEndRoleSource) it.next();
			removeAssER.add(assERs);
			AssociationRole ass= assERs.getAssociationRole();
			AssociationEndRoleTarget assERt=ass.getTarget();
			ClassifierNode cls=(ClassifierNode)assERt.getType();
			List list=new LinkedList();
			list.add(assERs);
			list.add(ass);
			list.add(assERt);
			list.add(cls);
			list.add(ass.eContainer());
			assERS.add(list );	
		
			cls.getTarget().remove(assERt);	
			((NavExpContainer)ass.eContainer()).getAssociationRole().remove(ass);
			//if(parent.getAssociationRole().contains(ass))parent.getAssociationRole().remove(ass);		

		}		
		classifier.getSource().removeAll(removeAssER);	
		removeAssER=new LinkedList();
		for (Iterator it = classifier.getTarget().iterator(); it.hasNext();) {
			AssociationEndRoleTarget assERt = (AssociationEndRoleTarget) it.next();
			removeAssER.add(assERt);
			AssociationRole ass=assERt.getAssociationRole();
			AssociationEndRoleSource assERs=ass.getSource();
			ClassifierNode cls=(ClassifierNode)assERs.getType();
			List list=new LinkedList();
			list.add(assERt);
			list.add(ass);
			list.add(assERs);
			list.add(cls);
			list.add(ass.eContainer());
			assERT.add(list );
			
			cls.getSource().remove(assERs);		
			((NavExpContainer)ass.eContainer()).getAssociationRole().remove(ass);
			//if(parent.getAssociationRole().contains(ass))parent.getAssociationRole().remove(ass);
		}	
		classifier.getTarget().removeAll(removeAssER);				
	}
		
	/**
	 * The implementation of the undo()
	 */
	public void undo(){
		for (Iterator it = assERS.iterator(); it.hasNext();) {
			List list = (LinkedList)it.next();
				
			AssociationRole ass=(AssociationRole)list.get(1);
			NavExpContainer parent=(NavExpContainer) list.get(4);
			parent.getAssociationRole().add(ass);
				
			AssociationEndRoleSource assERs=(AssociationEndRoleSource)list.get(0);	
			AssociationEndRoleTarget assERt=(AssociationEndRoleTarget)list.get(2);
				
			classifier.getSource().add(assERs);	
				
			ClassifierNode cls=(ClassifierNode)list.get(3);
			cls.getTarget().add(assERt);
				
			assERs.setType(classifier);	
			assERt.setType(cls);	
				
			assERs.setAssociationRole(ass);	
			assERt.setAssociationRole(ass);
				
			ass.setSource(assERs);
			ass.setTarget(assERt);
		}
			
		for (Iterator it = assERT.iterator(); it.hasNext();) {
			List list = (LinkedList)it.next();
				
			AssociationRole ass=(AssociationRole)list.get(1);
			NavExpContainer parent=(NavExpContainer) list.get(4);
			parent.getAssociationRole().add(ass);
				
			AssociationEndRoleTarget assERt=(AssociationEndRoleTarget)list.get(0);	
			AssociationEndRoleSource assERs=(AssociationEndRoleSource)list.get(2);
				
			classifier.getTarget().add(assERt);
					
			ClassifierNode cls=(ClassifierNode)list.get(3);
			cls.getSource().add(assERs);
				
			assERt.setType(classifier);	
			assERs.setType(cls);
				
			assERt.setAssociationRole(ass);	
			assERs.setAssociationRole(ass);
				
			ass.setSource(assERs);
			ass.setTarget(assERt);	
				
		}			
	}
	
	
}
