/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.dialogs;

import java.util.Iterator;
import java.util.LinkedList;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Shell;

import vocleditor.model.ConditionElement;

/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a
* for-profit company or business) then you should purchase
* a license - please visit www.cloudgarden.com for details.
*/
public class SetConditiontPropertyDialog extends org.eclipse.swt.widgets.Dialog {
	private Label label2;
	private Label label1;
	private Shell dialogShell;
	private Button apply;
	private Composite buttons;
	private Button removeCondition;
	private Button addCondition;
	private Button editCondition;
	private List conditionList;
	private Group conditionGroup;
	private Composite compositeAM;
	private Label con;
	private Label Txt;
	private Composite prName;
	
	
	private java.util.List conditions=new LinkedList();
	private String nameOfConstraint="";
	private boolean state=false;

 
	public SetConditiontPropertyDialog(Shell parent, int style) {
		super(parent, style);
	}

	/** Auto-generated event handler method */
	protected void editConditionMouseDown(MouseEvent evt){	
		if(conditionList.getSelectionIndex()== -1)return;
		int index = conditionList.getSelectionIndex();	
		ConditionElement conElem=(ConditionElement) conditions.get(index);
		AddConditionDialog aad = new AddConditionDialog(dialogShell,0);
		aad.setConElem(conElem);
		aad.open();		
	
		// check if the apply-button was clicked
		if (!aad.isState())return;

		conElem=aad.getConElem();
		conditions.set(index,conElem);
		changeConditionOfList(index,conElem);


	}
	
	/**
	* This method adds an Attribute to the list, 
	* specified by name, type and value.
	* Inserted as Label in the following format:
	* <name>: "<value>" [<type>]
	* @param name	- the attributes name
	* @param type	- the attributes type (e.g. String)
	* @param value	- the attributes value
	*/
	public void changeConditionOfList(int index, ConditionElement con) {	
		String strCondition="( " +con.getLeftVarName()
								 + con.getOp() ;
		if(con.getValue().trim().length()!=0)
			strCondition=strCondition + con.getValue();
		else
			strCondition=strCondition + con.getRightVarName();
		strCondition=strCondition + " )";
	
	
		String[] sel = conditionList.getItems();
		sel[index] = strCondition;
		conditionList.removeAll();
		for (int i = 0; i < sel.length; i++) {
			conditionList.add(sel[i]);
		}
	}

	/** Auto-generated event handler method */
	protected void addConditionMouseDown(MouseEvent evt){
		AddConditionDialog aad = new AddConditionDialog(dialogShell,0);
		aad.open();
		String strCondition="";
		// check if the apply-button was clicked
		if (!aad.isState()) return;	
		
		ConditionElement conElem =aad.getConElem();
		strCondition="( " +conElem.getLeftVarName() + conElem.getOp() ;
		if(conElem.isRightVar()){
			strCondition=strCondition + conElem.getRightVarName();
		}else{
			strCondition=strCondition + conElem.getValue();
		}
		
		strCondition=strCondition + " )";
		conditions.add(conElem);	
		// apdate the List
		conditionList.add(strCondition);
		initButtons(true);	
	}

	/** Auto-generated event handler method */
	protected void removeConditionMouseDown(MouseEvent evt){
		if(conditionList.getSelectionIndex()== -1)return;
		int index=conditionList.getSelectionIndex();
		conditionList.remove(index);
		conditions.remove(index);
		if(conditions.size()==0)initButtons(false);
	}

	/** Auto-generated event handler method */
	protected void applyMouseDown(MouseEvent evt){
		setState(true);
		dialogShell.close();
	}

	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			prName = new Composite(dialogShell,SWT.NULL);
			Txt = new Label(prName,SWT.NULL);
			con = new Label(prName,SWT.NULL);
			label1 = new Label(prName,SWT.NULL);
			label2 = new Label(prName,SWT.NULL);
			compositeAM = new Composite(dialogShell,SWT.NULL);
			conditionGroup = new Group(compositeAM,SWT.NULL);
			conditionList = new List(conditionGroup,SWT.BORDER);
			editCondition = new Button(conditionGroup,SWT.PUSH| SWT.CENTER);
			addCondition = new Button(conditionGroup,SWT.PUSH| SWT.CENTER);
			removeCondition = new Button(conditionGroup,SWT.PUSH| SWT.CENTER);
			buttons = new Composite(dialogShell,SWT.NULL);
			apply = new Button(buttons,SWT.PUSH| SWT.CENTER);
	
			dialogShell.setText("ClassifierRole Properties");
			dialogShell.setSize(new org.eclipse.swt.graphics.Point(488,425));
	
			GridData prNameLData = new GridData();
			prNameLData.verticalAlignment = GridData.CENTER;
			prNameLData.horizontalAlignment = GridData.BEGINNING;
			prNameLData.widthHint = 480;
			prNameLData.heightHint = 60;
			prNameLData.horizontalIndent = 0;
			prNameLData.horizontalSpan = 1;
			prNameLData.verticalSpan = 1;
			prNameLData.grabExcessHorizontalSpace = false;
			prNameLData.grabExcessVerticalSpace = false;
			prName.setLayoutData(prNameLData);
			prName.setSize(new org.eclipse.swt.graphics.Point(480,60));
			final Color prNamebackground = new Color(Display.getDefault(),255,255,255);
			prName.setBackground(prNamebackground);
			final Font prNamefont = new Font(Display.getDefault(),"Courier New",8,0);
			prName.setFont(prNamefont);
	
			Txt.setText("Properties:");
			Txt.setSize(new org.eclipse.swt.graphics.Point(111,21));
			Txt.setBackground(prNamebackground);
			Txt.setBounds(new org.eclipse.swt.graphics.Rectangle(95,6,111,21));
			final Font Txtfont = new Font(Display.getDefault(),"Courier New",12,1);
			Txt.setFont(Txtfont);
	
			con.setText("conditions");
			con.setSize(new org.eclipse.swt.graphics.Point(121,22));
			con.setBackground(prNamebackground);
			con.setBounds(new org.eclipse.swt.graphics.Rectangle(214,29,121,22));
			con.setFont(Txtfont);
	
			label1.setText("label1");
			final org.eclipse.swt.graphics.Image label1image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newEEnum_wiz.gif"));
			label1image.setBackground(label1.getBackground());
			label1.setImage(label1image);
			label1.setSize(new org.eclipse.swt.graphics.Point(75,49));
			label1.setBounds(new org.eclipse.swt.graphics.Rectangle(399,4,75,49));
	
			label2.setText("label2");
			final org.eclipse.swt.graphics.Image label2image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newEEnum_wizR.GIF"));
			label2image.setBackground(label2.getBackground());
			label2.setImage(label2image);
			label2.setSize(new org.eclipse.swt.graphics.Point(74,51));
			label2.setBounds(new org.eclipse.swt.graphics.Rectangle(5,3,74,51));
			prName.setLayout(null);
	
			GridData compositeAMLData = new GridData();
			compositeAMLData.verticalAlignment = GridData.CENTER;
			compositeAMLData.horizontalAlignment = GridData.BEGINNING;
			compositeAMLData.widthHint = 480;
			compositeAMLData.heightHint = 300;
			compositeAMLData.horizontalIndent = 0;
			compositeAMLData.horizontalSpan = 1;
			compositeAMLData.verticalSpan = 1;
			compositeAMLData.grabExcessHorizontalSpace = false;
			compositeAMLData.grabExcessVerticalSpace = false;
			compositeAM.setLayoutData(compositeAMLData);
			compositeAM.setSize(new org.eclipse.swt.graphics.Point(480,300));
	
			GridData conditionGroupLData = new GridData();
			conditionGroupLData.verticalAlignment = GridData.CENTER;
			conditionGroupLData.horizontalAlignment = GridData.BEGINNING;
			conditionGroupLData.widthHint = 464;
			conditionGroupLData.heightHint = 278;
			conditionGroupLData.horizontalIndent = 0;
			conditionGroupLData.horizontalSpan = 1;
			conditionGroupLData.verticalSpan = 1;
			conditionGroupLData.grabExcessHorizontalSpace = false;
			conditionGroupLData.grabExcessVerticalSpace = false;
			conditionGroup.setLayoutData(conditionGroupLData);
			conditionGroup.setText("Conditions");
			conditionGroup.setSize(new org.eclipse.swt.graphics.Point(464,278));
			conditionGroup.setEnabled(true);
			conditionGroup.setFont(prNamefont);
	
			FormData conditionListLData = new FormData();
			conditionListLData.height = 219;
			conditionListLData.width = 453;
			conditionListLData.left =  new FormAttachment(5, 1000, 0);
			conditionListLData.right =  new FormAttachment(996, 1000, 0);
			conditionListLData.top =  new FormAttachment(23, 1000, 0);
			conditionListLData.bottom =  new FormAttachment(829, 1000, 0);
			conditionList.setLayoutData(conditionListLData);
			conditionList.setSize(new org.eclipse.swt.graphics.Point(453,220));
			conditionList.setEnabled(true);
	
			FormData editConditionLData = new FormData();
			editConditionLData.height = 27;
			editConditionLData.width = 90;
			editConditionLData.left =  new FormAttachment(378, 1000, 0);
			editConditionLData.right =  new FormAttachment(572, 1000, 0);
			editConditionLData.top =  new FormAttachment(872, 1000, 0);
			editConditionLData.bottom =  new FormAttachment(968, 1000, 0);
			editCondition.setLayoutData(editConditionLData);
			editCondition.setText("EDIT");
			editCondition.setSize(new org.eclipse.swt.graphics.Point(90,27));
			editCondition.setEnabled(false);
			final Font editConditionfont = new Font(Display.getDefault(),"Courier New",10,1);
			editCondition.setFont(editConditionfont);
			editCondition.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					editConditionMouseDown(evt);
				}
			});
	
			FormData addConditionLData = new FormData();
			addConditionLData.height = 28;
			addConditionLData.width = 90;
			addConditionLData.left =  new FormAttachment(29, 1000, 0);
			addConditionLData.right =  new FormAttachment(223, 1000, 0);
			addConditionLData.top =  new FormAttachment(870, 1000, 0);
			addConditionLData.bottom =  new FormAttachment(969, 1000, 0);
			addCondition.setLayoutData(addConditionLData);
			addCondition.setText("ADD");
			addCondition.setSize(new org.eclipse.swt.graphics.Point(90,28));
			addCondition.setEnabled(true);
			addCondition.setFont(editConditionfont);
			addCondition.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					addConditionMouseDown(evt);
				}
			});
	
			FormData removeConditionLData = new FormData();
			removeConditionLData.height = 27;
			removeConditionLData.width = 90;
			removeConditionLData.left =  new FormAttachment(783, 1000, 0);
			removeConditionLData.right =  new FormAttachment(977, 1000, 0);
			removeConditionLData.top =  new FormAttachment(872, 1000, 0);
			removeConditionLData.bottom =  new FormAttachment(968, 1000, 0);
			removeCondition.setLayoutData(removeConditionLData);
			removeCondition.setText("REMOVE");
			removeCondition.setSize(new org.eclipse.swt.graphics.Point(90,27));
			removeCondition.setEnabled(false);
			removeCondition.setFont(editConditionfont);
			removeCondition.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					removeConditionMouseDown(evt);
				}
			});
			FormLayout conditionGroupLayout = new FormLayout();
			conditionGroup.setLayout(conditionGroupLayout);
			conditionGroupLayout.marginWidth = 0;
			conditionGroupLayout.marginHeight = 0;
			conditionGroup.layout();
			GridLayout compositeAMLayout = new GridLayout(2, true);
			compositeAM.setLayout(compositeAMLayout);
			compositeAMLayout.marginWidth = 5;
			compositeAMLayout.marginHeight = 5;
			compositeAMLayout.numColumns = 2;
			compositeAMLayout.makeColumnsEqualWidth = true;
			compositeAMLayout.horizontalSpacing = 5;
			compositeAMLayout.verticalSpacing = 5;
			compositeAM.layout();
	
			GridData buttonsLData = new GridData();
			buttonsLData.verticalAlignment = GridData.CENTER;
			buttonsLData.horizontalAlignment = GridData.BEGINNING;
			buttonsLData.widthHint = 470;
			buttonsLData.heightHint = 45;
			buttonsLData.horizontalIndent = 0;
			buttonsLData.horizontalSpan = 1;
			buttonsLData.verticalSpan = 1;
			buttonsLData.grabExcessHorizontalSpace = false;
			buttonsLData.grabExcessVerticalSpace = false;
			buttons.setLayoutData(buttonsLData);
			buttons.setSize(new org.eclipse.swt.graphics.Point(470,45));
	
			FormData applyLData = new FormData();
			applyLData.height = 27;
			applyLData.width = 116;
			applyLData.left =  new FormAttachment(713, 1000, 0);
			applyLData.right =  new FormAttachment(960, 1000, 0);
			applyLData.top =  new FormAttachment(233, 1000, 0);
			applyLData.bottom =  new FormAttachment(833, 1000, 0);
			apply.setLayoutData(applyLData);
			apply.setText("CLOSE");
			apply.setSize(new org.eclipse.swt.graphics.Point(116,27));
			apply.setFont(editConditionfont);
			apply.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					applyMouseDown(evt);
				}
			});
			FormLayout buttonsLayout = new FormLayout();
			buttons.setLayout(buttonsLayout);
			buttonsLayout.marginWidth = 0;
			buttonsLayout.marginHeight = 0;
			buttons.layout();
			GridLayout dialogShellLayout = new GridLayout(1, true);
			dialogShell.setLayout(dialogShellLayout);
			dialogShellLayout.marginWidth = 5;
			dialogShellLayout.marginHeight = 5;
			dialogShellLayout.numColumns = 1;
			dialogShellLayout.makeColumnsEqualWidth = true;
			dialogShellLayout.horizontalSpacing = 5;
			dialogShellLayout.verticalSpacing = 5;
			dialogShell.layout();
			dialogShell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					prNamebackground.dispose();
					prNamefont.dispose();
					Txtfont.dispose();
					label1image.dispose();
					label2image.dispose();
					editConditionfont.dispose();
				}
			});
			Rectangle bounds = dialogShell.computeTrim(0, 0, 488,425);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI(){
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI(){
		setValues();
	}
	
	
	private void initButtons(boolean b){
		editCondition.setEnabled(b);
		removeCondition.setEnabled(b);
	}
	
	/**
	 * This method sets the Values to the Dialog by reading them form
	 * the ClassifierRole and inserting to the Dialogs elements.
	 * @param clr - the ClassifierRole which properties to show
	 */
	private void setValues() {	
		// set the Name and VariableName of this classifier
		dialogShell.setText("Condition Properties: " + getNameOfConstraint());	
		if(conditions.size()!=0)initButtons(true);
		else initButtons(false);	
		// add all Condition
		Iterator it=conditions.iterator();
		while( it.hasNext()) {
			ConditionElement con = (ConditionElement) it.next();
			String strCondition="( " +con.getLeftVarName()
								 + con.getOp() ;
			if(con.getValue().trim().length()!=0)
				strCondition=strCondition + con.getValue();
			else
				strCondition=strCondition + con.getRightVarName();
			strCondition=strCondition + " ) :" + con.getLeftVarType();
				conditionList.add(strCondition);
		}
	
	}
	

	/** Auto-generated main method */
	public static void main(String[] args){
		showGUI();
	}

	/**
	* This static method creates a new instance of this class and shows
	* it inside a new Shell.
	*
	* It is a convenience method for showing the GUI, but it can be
	* copied and used as a basis for your own code.	*
	* It is auto-generated code - the body of this method will be
	* re-generated after any changes are made to the GUI.
	* However, if you delete this method it will not be re-created.	*/
	public static void showGUI(){
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			SetConditiontPropertyDialog inst = new SetConditiontPropertyDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/**
	 * @return
	 */
	public java.util.List getConditions() {
		return conditions;
	}

	/**
	 * @return
	 */
	public String getNameOfConstraint() {
		return nameOfConstraint;
	}

	/**
	 * @return
	 */
	public boolean isState() {
		return state;
	}

	/**
	 * @param list
	 */
	public void setCondition(java.util.List list) {
		conditions.clear();
		conditions.addAll(list);
	}

	/**
	 * @param string
	 */
	public void setNameOfConstraint(String string) {
		nameOfConstraint = string;
	}

	/**
	 * @param b
	 */
	public void setState(boolean b) {
		state = b;
	}

}
