/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.edit.policy;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ConnectionEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import vocleditor.commands.connect.IsInDisconnectCommand;
import vocleditor.commands.connect.NavDisconnectCommand;
import VOCLModel.AssociationNav;
import VOCLModel.AssociationRole;
import VOCLModel.ClassifierNode;
import VOCLModel.NavExpContainer;

/**
 * @author eddi
 *
 */
public class AssociationRoleEditPolicy extends ConnectionEditPolicy {

	/**
	 * 
	 */
	public AssociationRoleEditPolicy() {
		super();
	}



	/* (non-Javadoc)
	 * @see org.eclipse.gef.editpolicies.ConnectionEditPolicy#getDeleteCommand(org.eclipse.gef.requests.GroupRequest)
	 */
	protected Command getDeleteCommand(GroupRequest request) {
		AssociationRole ass=(AssociationRole)getHost().getModel();
		if(ass instanceof AssociationNav){
			NavDisconnectCommand c = new NavDisconnectCommand();
			c.setContainer((NavExpContainer)ass.eContainer());
			c.setAssociation(ass);
			c.setAssERS(ass.getSource());
			c.setAssERT(ass.getTarget());
			ClassifierNode cNS = ass.getSource().getType();	
			c.setSource((ClassifierNode)ass.getSource().getType());
			ClassifierNode cNT = ass.getTarget().getType();
			c.setTarget((ClassifierNode)ass.getTarget().getType());
			return c;
		}else{
			IsInDisconnectCommand c = new IsInDisconnectCommand();
			c.setContainer((NavExpContainer)ass.eContainer());
			c.setAssociation(ass);
			c.setAssERS(ass.getSource());
			c.setAssERT(ass.getTarget());
			ClassifierNode cNS = ass.getSource().getType();	
			c.setSource((ClassifierNode)ass.getSource().getType());
			ClassifierNode cNT = ass.getTarget().getType();
			c.setTarget((ClassifierNode)ass.getTarget().getType());
			return c;		
		}
	}
	
}
