/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.edit.policy;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import vocleditor.commands.delete.DeleteClassifierNodeCommand;
import VOCLModel.ClassifierNode;
import VOCLModel.NavExpContainer;


public class ClassifierRoleComponentEditPolicy
	extends ComponentEditPolicy {

		/**
		 * 
		 */
		public ClassifierRoleComponentEditPolicy() {
			super();
		}

		/* (non-Javadoc)
		 * @see org.eclipse.gef.editpolicies.ComponentEditPolicy#createDeleteCommand(org.eclipse.gef.requests.GroupRequest)
		 */
		protected Command createDeleteCommand(GroupRequest deleteRequest) {
			NavExpContainer parent = (NavExpContainer) getHost().getParent().getModel();
			Command result = null;	
			if( getHost().getModel() instanceof ClassifierNode) {
				DeleteClassifierNodeCommand deleteCmd = new DeleteClassifierNodeCommand();
				deleteCmd.setParent(parent);
				deleteCmd.setClassifierNode((ClassifierNode) getHost().getModel());
				result = deleteCmd;
			}
		
			return result;
		}


}

