/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.figure;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.AbstractBorder;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.draw2d.Graphics;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;



import java.util.Iterator;
import java.util.List;

public class CompartmentFigure extends Figure {

  public CompartmentFigure() {
    ToolbarLayout layout = new ToolbarLayout();
    layout.setMinorAlignment(ToolbarLayout.ALIGN_TOPLEFT);
    layout.setStretchMinorAxis(false);
    layout.setSpacing(2);
    setLayoutManager(layout);
    setBorder(new CompartmentFigureBorder());
  }
  
  public Dimension getPreferredSize(int wHint, int hHint) {
  	List list = this.getChildren();
  	Iterator it = list.iterator();
  	Dimension dim = new Dimension(0,0);
  	
  	while(it.hasNext()) {
  		Label label = (Label)it.next();
  		if (label != null) {
  			Font f = label.getFont();
 			if (f != null) {
		  		Dimension diml = label.getPreferredSize();
		  		dim.height += diml.height;
		  		dim.width = Math.max(dim.width,diml.width);
 			} else {
 				label.setFont(new Font(null, "Arial", 8, SWT.NORMAL));
 				try {
					Dimension diml = label.getPreferredSize();
					// if image exists, add the size
					Image img = label.getIcon();
					if (img != null) {
						Rectangle rect = img.getBounds();
						diml.width += rect.width;
						diml.height += rect.height;
					}
					
					dim.height += diml.height;
					dim.width = Math.max(dim.width,diml.width);
					
 				} catch (Exception e) {
 					e.printStackTrace();
 				}
 			}
  		}  		
  	}
  	dim.width += 5;
  	// dim.height += (list.size() * 2);
	dim.height = (list.size() * 18);
  	setPreferredSize(dim);
  	return dim;
  }
  	
  
    
  public class CompartmentFigureBorder extends AbstractBorder {
    public Insets getInsets(IFigure figure) {
      return new Insets(1,0,0,0);
    }
    public void paint(IFigure figure, Graphics graphics, Insets insets) {
      graphics.drawLine(getPaintRectangle(figure, insets).getTopLeft(),
                        tempRect.getTopRight());
    }
  }
}


