/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.figure;

import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.swt.graphics.Image;

import vocleditor.editors.VOCLEditorConstants;


public class ConditionFigure extends CompartmentFigure {


	private Label con;
	
	public ConditionFigure(String string){
		ToolbarLayout layout = new ToolbarLayout();
		layout.setMinorAlignment(ToolbarLayout.ALIGN_TOPLEFT);
		layout.setStretchMinorAxis(true);
		layout.setSpacing(2);
		setLayoutManager(layout);
		setBorder(new CompartmentFigureBorder());
		Image image=new Image(null,ConditionFigure.class.getResourceAsStream("gif/condition.gif"));
		
		con=new Label(string,image);
		setBackgroundColor(VOCLEditorConstants.classColor);
		add(con);	
	}
	
	public void setLabel(String string){
		con.setText(string);
		revalidate();
	}
}
