/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.figure;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.Panel;
import org.eclipse.draw2d.geometry.Dimension;

import vocleditor.editors.VOCLEditorConstants;



/**
 * @author vilapower
 */
public class ConstraintFigure extends Figure{
	
	private Label context;
	private String strContext="";
	private Panel body;



	/**
	 * Creates a new LEDFigure
	 */
	public ConstraintFigure(String str) {	
		// store the values of class and variablename	
		// place everything inside a BorderLayout
		// and a BorderLayout

		BorderLayout layout =new BorderLayout(); 
		setLayoutManager(layout);
		setBorder(new LineBorder(ColorConstants.black,3));
		setBackgroundColor(ColorConstants.white);
	
		context=new Label(str);
		context.setFont(VOCLEditorConstants.classFont);
		strContext=str;
		context.setBorder(new LineBorder(ColorConstants.black,1));
		add(context,BorderLayout.TOP);
		body=new Panel();
		body.setLayoutManager(new BorderLayout());
		add(body,BorderLayout.CENTER);
		
	}	


	/**
	 * @see org.eclipse.draw2d.Figure#getPreferredSize(int, int)
	 */
	public Dimension getPreferredSize(int w, int h) {
		return getSize();
	}
	

	/**
	 * @return
	 */
	public String getContext() {return strContext;}

	/**
	 * @param string
	 */
	public void setContext(String string) {strContext = string;}


	/**
	 * @return
	 */
	public Panel getBody() {
		return body;
	}

	/**
	 * @param panel
	 */
	public void setBody(Panel panel) {
		body = panel;
	}

}