/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.model;


public class ConditionElement{
	
	String op="";
	String value="";
	String leftVarName="";
	String leftVarType="";
	String rightVarName="";
	String rightVarType="";
	private boolean rightVar=false;
		
	public ConditionElement(){}
		
	public ConditionElement(String op,String value,String leftVarName,String leftVarType,
							String rightVarName,String rightVarType,boolean rightVar){
		this.op=op;
		this.value=value;
		this.leftVarName=leftVarName;
		this.leftVarType=leftVarType;
		this.rightVarName=rightVarName;
		this.rightVarType=rightVarType;
		this.rightVar=rightVar;
	}
	
	public ConditionElement(ConditionElement con){
		this.op=con.op;
		this.value=con.value;
		this.leftVarName=con.leftVarName;
		this.leftVarType=con.leftVarType;
		this.rightVarName=con.rightVarName;
		this.rightVarType=con.rightVarType;
		this.rightVar=con.rightVar;
	}
		
	/**
	 * @return
	 */
	public String getLeftVarType() {
		return leftVarType;
	}

	/**
	 * @return
	 */
	public String getOp() {
		return op;
	}

	/**
	 * @return
	 */
	public String getRightVarName() {
		return rightVarName;
	}

	/**
	 * @return
	 */
	public String getRightVarType() {
		return rightVarType;
	}

	/**
	 * @return
	 */
	public String getValue() {
		return value;
	}

	/**
	 * @param string
	 */
	public void setLeftVarType(String string) {
		leftVarType = string;
	}

	/**
	 * @param string
	 */
	public void setOp(String string) {
		op = string;
	}

	/**
	 * @param string
	 */
	public void setRightVarName(String string) {
		rightVarName = string;
	}

	/**
	 * @param string
	 */
	public void setRightVarType(String string) {
		rightVarType = string;
	}

	/**
	 * @param string
	 */
	public void setValue(String string) {
		value = string;
	}

	/**
	 * @return
	 */
	public boolean isRightVar() {
		return rightVar;
	}

	/**
	 * @param b
	 */
	public void setRightVar(boolean b) {
		rightVar = b;
	}

	/**
	 * @return
	 */
	public String getLeftVarName() {
		return leftVarName;
	}

	/**
	 * @param string
	 */
	public void setLeftVarName(String string) {
		leftVarName = string;
	}

}

