/*
 * Created on 05.11.2004
 *
 * Window - Preferences - Java - Code Style - Code Templates
 */
package vocleditor.model;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import VOCLModel.AssociationEndRoleSource;
import VOCLModel.AssociationEndRoleTarget;
import VOCLModel.AssociationIsIn;
import VOCLModel.AssociationRole;
import VOCLModel.ClassifierNode;
import VOCLModel.ClassifierRole;
import VOCLModel.NavExpContainer;
import VOCLModel.SetClassifierRole;
import VOCLModel.VOCLModel4Factory;

/**
 * @author eddi
 *
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class IsIn {
	
	private List list=new LinkedList();
	private VOCLModel4Factory mfc = VOCLModelManager.getFactory();

	
	/**
	 * 
	 */
	public IsIn() {
		list.clear();
	}
	/**
	 * 
	 */
	public IsIn(SetClassifierRole predicate,ClassifierRole iterator,NavExpContainer container) {
		Structure struct=new Structure(predicate,iterator,container);
		list.add(struct);
	}

	public void add(SetClassifierRole predicate,ClassifierRole iterator,NavExpContainer container){
		Structure struct=new Structure(predicate,iterator,container);
		list.add(struct);		
	}
	
	public void clear(){
		list.clear();		
	}
	
	public void deleteAllIsIn(){
		Iterator it=list.iterator();
		while(it.hasNext()){
			Structure struct=(Structure) it.next();
			SetClassifierRole predicate=struct.getPredicate();
			ClassifierRole iterator=struct.getIterator();
			NavExpContainer container=struct.getContainer();
			deleteIsIn(predicate,iterator,container);
		}
		
	}
	
	public void addAndDeleteIsIn(SetClassifierRole predicate,ClassifierRole iterator,NavExpContainer container){
		Structure struct=new Structure(predicate,iterator,container);
		if( testIfIn(struct)){
			list.add(struct);	
			deleteIsIn(predicate,iterator,container);
		}
	}
	
	private boolean  testIfIn(Structure struct){
		Iterator it=list.iterator();
		while(it.hasNext()){
			Structure s=(Structure) it.next();
			if(s.getPredicate().equals(struct.getPredicate())&
			   s.getIterator().equals(struct.getIterator()))return false;
		}
		return true;
		
	}
	public void deleteIsIn(SetClassifierRole predicate,ClassifierRole iterator,NavExpContainer container){
		ClassifierNode clsIt=null;
		Iterator it = predicate.getSource().iterator();
		while ( it.hasNext()&& !iterator.equals(clsIt)) {
			AssociationEndRoleSource assERs=(AssociationEndRoleSource) it.next();
			AssociationRole ass= assERs.getAssociationRole();
			if(ass instanceof AssociationIsIn ){
				AssociationEndRoleTarget assERt=ass.getTarget();
				clsIt=assERt.getType();
				if(clsIt.equals(iterator)){
					predicate.getSource().remove(assERs);
					iterator.getTarget().remove(assERt);
					container.getAssociationRole().remove(ass);
				}
			}
		}			
		it = predicate.getTarget().iterator();
		while ( it.hasNext()&& !iterator.equals(clsIt)) {
			AssociationEndRoleTarget assERt = (AssociationEndRoleTarget) it.next();
			AssociationRole ass=assERt.getAssociationRole();
			if(ass instanceof AssociationIsIn ){
				AssociationEndRoleSource assERs=ass.getSource();
				clsIt=assERs.getType();	
				if(clsIt.equals(iterator)){
					predicate.getTarget().remove(assERt);
					iterator.getSource().remove(assERs);
					container.getAssociationRole().remove(ass);
				}
			}
		}		
	}
	
	public void createAllIsIn(){
		Iterator it=list.iterator();
		while(it.hasNext()){
			Structure struct=(Structure) it.next();
			SetClassifierRole predicate=struct.getPredicate();
			ClassifierRole iterator=struct.getIterator();
			NavExpContainer container=struct.getContainer();
			createIsIn(predicate,iterator,container);
		}
		
	}
	
	public void addAndCreateIsIn(SetClassifierRole predicate,ClassifierRole iterator,NavExpContainer container){
		Structure struct=new Structure(predicate,iterator,container);
		if( testIfIn(struct)){
			list.add(struct);	
			createIsIn(predicate,iterator,container);
		}
	}
	
	public void createIsIn(SetClassifierRole predicate,ClassifierRole iterator,NavExpContainer container){
		AssociationEndRoleSource assERs=mfc.createAssociationEndRoleSource();
		AssociationEndRoleTarget assERt=mfc.createAssociationEndRoleTarget();
		AssociationIsIn ass=mfc.createAssociationIsIn();
		
		container.getAssociationRole().add(ass);
		
		assERs.setName("");
		ass.setSource(assERs);
		assERs.setAssociationRole(ass);
		assERs.setNumberOfAnchor(3);	
			
		assERt.setName("IsIn");		
		ass.setTarget(assERt);
		assERt.setAssociationRole(ass);
		assERt.setNumberOfAnchor(1);
			
		predicate.getSource().add(assERs);
		iterator.getTarget().add(assERt);
		assERs.setType(predicate);	
		assERt.setType(iterator);		
	}
	
	public class Structure{
		private SetClassifierRole predicate;
		private ClassifierRole iterator;
		private NavExpContainer container;
		
		public Structure(SetClassifierRole predicate,ClassifierRole iterator,NavExpContainer container){
			this.predicate=predicate;
			this.iterator=iterator;
			this.container=container;
			
		}
		/**
		 * @return Returns the iterator.
		 */
		public ClassifierRole getIterator() {
			return iterator;
		}
		/**
		 * @param iterator The iterator to set.
		 */
		public void setIterator(ClassifierRole iterator) {
			this.iterator = iterator;
		}
		/**
		 * @return Returns the predicate.
		 */
		public SetClassifierRole getPredicate() {
			return predicate;
		}
		/**
		 * @param predicate The predicate to set.
		 */
		public void setPredicate(SetClassifierRole predicate) {
			this.predicate = predicate;
		}
		/**
		 * @return Returns the container.
		 */
		public NavExpContainer getContainer() {
			return container;
		}
		/**
		 * @param container The container to set.
		 */
		public void setContainer(NavExpContainer container) {
			this.container = container;
		}
	}
}
